<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'ErrorMessage' => '\\StructType\\ErrorMessage',
            'FobArray' => '\\ArrayType\\FobArray',
            'Fob' => '\\StructType\\Fob',
            'GetAvailableLocationsRequest' => '\\StructType\\GetAvailableLocationsRequest',
            'AvailableLocation' => '\\StructType\\AvailableLocation',
            'GetAvailableLocationsResponse' => '\\StructType\\GetAvailableLocationsResponse',
            'AvailableLocationArray' => '\\ArrayType\\AvailableLocationArray',
            'GetDecorationColorsRequest' => '\\StructType\\GetDecorationColorsRequest',
            'Color' => '\\StructType\\Color',
            'DecorationMethod' => '\\StructType\\DecorationMethod',
            'GetDecorationColorsResponse' => '\\StructType\\GetDecorationColorsResponse',
            'DecorationColors' => '\\StructType\\DecorationColors',
            'ColorArray' => '\\ArrayType\\ColorArray',
            'DecorationMethodArray' => '\\ArrayType\\DecorationMethodArray',
            'GetConfigurationAndPricingRequest' => '\\StructType\\GetConfigurationAndPricingRequest',
            'Part' => '\\StructType\\Part',
            'PartPriceArray' => '\\ArrayType\\PartPriceArray',
            'LocationIdArray' => '\\ArrayType\\LocationIdArray',
            'LocationId' => '\\StructType\\LocationId',
            'PartPrice' => '\\StructType\\PartPrice',
            'Location' => '\\StructType\\Location',
            'DecorationArray' => '\\ArrayType\\DecorationArray',
            'Decoration' => '\\StructType\\Decoration',
            'ChargeArray' => '\\ArrayType\\ChargeArray',
            'Charge' => '\\StructType\\Charge',
            'ChargePriceArray' => '\\ArrayType\\ChargePriceArray',
            'ChargePrice' => '\\StructType\\ChargePrice',
            'Configuration' => '\\StructType\\Configuration',
            'PartArray' => '\\ArrayType\\PartArray',
            'LocationArray' => '\\ArrayType\\LocationArray',
            'GetConfigurationAndPricingResponse' => '\\StructType\\GetConfigurationAndPricingResponse',
            'GetFobPointsRequest' => '\\StructType\\GetFobPointsRequest',
            'FobPoint' => '\\StructType\\FobPoint',
            'CurrencySupportedArray' => '\\ArrayType\\CurrencySupportedArray',
            'ProductArray' => '\\ArrayType\\ProductArray',
            'CurrencySupported' => '\\StructType\\CurrencySupported',
            'Product' => '\\StructType\\Product',
            'GetFobPointsResponse' => '\\StructType\\GetFobPointsResponse',
            'FobPointArray' => '\\ArrayType\\FobPointArray',
            'GetAvailableChargesRequest' => '\\StructType\\GetAvailableChargesRequest',
            'AvailableCharge' => '\\StructType\\AvailableCharge',
            'GetAvailableChargesResponse' => '\\StructType\\GetAvailableChargesResponse',
            'AvailableChargeArray' => '\\ArrayType\\AvailableChargeArray',
        );
    }
}
