<?php

namespace EnumType;

/**
 * This class stands for QuantityUomType EnumType
 * Meta informations extracted from the WSDL
 * - documentation: The type of Quantity UOM
 * @subpackage Enumerations
 */
class QuantityUomType
{
    /**
     * Constant for value 'BX'
     * @return string 'BX'
     */
    const VALUE_BX = 'BX';
    /**
     * Constant for value 'CA'
     * @return string 'CA'
     */
    const VALUE_CA = 'CA';
    /**
     * Constant for value 'DZ'
     * @return string 'DZ'
     */
    const VALUE_DZ = 'DZ';
    /**
     * Constant for value 'EA'
     * @return string 'EA'
     */
    const VALUE_EA = 'EA';
    /**
     * Constant for value 'KT'
     * @return string 'KT'
     */
    const VALUE_KT = 'KT';
    /**
     * Constant for value 'PR'
     * @return string 'PR'
     */
    const VALUE_PR = 'PR';
    /**
     * Constant for value 'PK'
     * @return string 'PK'
     */
    const VALUE_PK = 'PK';
    /**
     * Constant for value 'RL'
     * @return string 'RL'
     */
    const VALUE_RL = 'RL';
    /**
     * Constant for value 'ST'
     * @return string 'ST'
     */
    const VALUE_ST = 'ST';
    /**
     * Constant for value 'SL'
     * @return string 'SL'
     */
    const VALUE_SL = 'SL';
    /**
     * Constant for value 'TH'
     * @return string 'TH'
     */
    const VALUE_TH = 'TH';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_BX
     * @uses self::VALUE_CA
     * @uses self::VALUE_DZ
     * @uses self::VALUE_EA
     * @uses self::VALUE_KT
     * @uses self::VALUE_PR
     * @uses self::VALUE_PK
     * @uses self::VALUE_RL
     * @uses self::VALUE_ST
     * @uses self::VALUE_SL
     * @uses self::VALUE_TH
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_BX,
            self::VALUE_CA,
            self::VALUE_DZ,
            self::VALUE_EA,
            self::VALUE_KT,
            self::VALUE_PR,
            self::VALUE_PK,
            self::VALUE_RL,
            self::VALUE_ST,
            self::VALUE_SL,
            self::VALUE_TH,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
