<?php

namespace EnumType;

/**
 * This class stands for weightUomEnum EnumType
 * @subpackage Enumerations
 */
class WeightUomEnum
{
    /**
     * Constant for value 'ME'
     * @return string 'ME'
     */
    const VALUE_ME = 'ME';
    /**
     * Constant for value 'KG'
     * @return string 'KG'
     */
    const VALUE_KG = 'KG';
    /**
     * Constant for value 'OZ'
     * @return string 'OZ'
     */
    const VALUE_OZ = 'OZ';
    /**
     * Constant for value 'LB'
     * @return string 'LB'
     */
    const VALUE_LB = 'LB';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_ME
     * @uses self::VALUE_KG
     * @uses self::VALUE_OZ
     * @uses self::VALUE_LB
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_ME,
            self::VALUE_KG,
            self::VALUE_OZ,
            self::VALUE_LB,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
