<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetAvailableChargesRequest StructType
 * @subpackage Structs
 */
class GetAvailableChargesRequest extends AbstractStructBase
{
    /**
     * The wsVersion
     * Meta informations extracted from the WSDL
     * - ref: ns3:wsVersion
     * - documentation: The Standard Version of the Web Service being referenced
     * - maxLength: 64
     * - minLength: 1
     * @var string
     */
    public $wsVersion;
    /**
     * The id
     * Meta informations extracted from the WSDL
     * - ref: ns3:id
     * - documentation: The customer Id or any other agreed upon Id.
     * - maxLength: 64
     * - minLength: 1
     * @var string
     */
    public $id;
    /**
     * The password
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - ref: ns3:password
     * - documentation: The password associated with the Id
     * - maxLength: 64
     * - minLength: 1
     * @var string
     */
    public $password;
    /**
     * The productId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - ref: ns3:productId
     * - documentation: The product ID
     * - maxLength: 64
     * - minLength: 1
     * @var string
     */
    public $productId;
    /**
     * The localizationCountry
     * Meta informations extracted from the WSDL
     * - ref: ns3:localizationCountry
     * - documentation: ISO 3166-1 Alpha 2 code for Country
     * - maxLength: 2
     * - minLength: 2
     * @var string
     */
    public $localizationCountry;
    /**
     * The localizationLanguage
     * Meta informations extracted from the WSDL
     * - ref: ns3:localizationLanguage
     * - documentation: ISO 639-1 Alpha 2 code for Language
     * - maxLength: 2
     * - minLength: 2
     * @var string
     */
    public $localizationLanguage;
    /**
     * Constructor method for GetAvailableChargesRequest
     * @uses GetAvailableChargesRequest::setWsVersion()
     * @uses GetAvailableChargesRequest::setId()
     * @uses GetAvailableChargesRequest::setPassword()
     * @uses GetAvailableChargesRequest::setProductId()
     * @uses GetAvailableChargesRequest::setLocalizationCountry()
     * @uses GetAvailableChargesRequest::setLocalizationLanguage()
     * @param string $wsVersion
     * @param string $id
     * @param string $password
     * @param string $productId
     * @param string $localizationCountry
     * @param string $localizationLanguage
     */
    public function __construct($wsVersion = null, $id = null, $password = null, $productId = null, $localizationCountry = null, $localizationLanguage = null)
    {
        $this
            ->setWsVersion($wsVersion)
            ->setId($id)
            ->setPassword($password)
            ->setProductId($productId)
            ->setLocalizationCountry($localizationCountry)
            ->setLocalizationLanguage($localizationLanguage);
    }
    /**
     * Get wsVersion value
     * @return string|null
     */
    public function getWsVersion()
    {
        return $this->wsVersion;
    }
    /**
     * Set wsVersion value
     * @param string $wsVersion
     * @return \StructType\GetAvailableChargesRequest
     */
    public function setWsVersion($wsVersion = null)
    {
        // validation for constraint: maxLength
        if ((is_scalar($wsVersion) && strlen($wsVersion) > 64) || (is_array($wsVersion) && count($wsVersion) > 64)) {
            throw new \InvalidArgumentException(sprintf('Invalid length, please provide an array with 64 element(s) or a scalar of 64 character(s) at most, "%d" length given', is_scalar($wsVersion) ? strlen($wsVersion) : count($wsVersion)), __LINE__);
        }
        // validation for constraint: minLength
        if ((is_scalar($wsVersion) && strlen($wsVersion) < 1) || (is_array($wsVersion) && count($wsVersion) < 1)) {
            throw new \InvalidArgumentException('Invalid length, please provide an array with 1 element(s) or a scalar of 1 character(s) at least', __LINE__);
        }
        // validation for constraint: string
        if (!is_null($wsVersion) && !is_string($wsVersion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($wsVersion)), __LINE__);
        }
        $this->wsVersion = $wsVersion;
        return $this;
    }
    /**
     * Get id value
     * @return string|null
     */
    public function getId()
    {
        return $this->id;
    }
    /**
     * Set id value
     * @param string $id
     * @return \StructType\GetAvailableChargesRequest
     */
    public function setId($id = null)
    {
        // validation for constraint: maxLength
        if ((is_scalar($id) && strlen($id) > 64) || (is_array($id) && count($id) > 64)) {
            throw new \InvalidArgumentException(sprintf('Invalid length, please provide an array with 64 element(s) or a scalar of 64 character(s) at most, "%d" length given', is_scalar($id) ? strlen($id) : count($id)), __LINE__);
        }
        // validation for constraint: minLength
        if ((is_scalar($id) && strlen($id) < 1) || (is_array($id) && count($id) < 1)) {
            throw new \InvalidArgumentException('Invalid length, please provide an array with 1 element(s) or a scalar of 1 character(s) at least', __LINE__);
        }
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($id)), __LINE__);
        }
        $this->id = $id;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \StructType\GetAvailableChargesRequest
     */
    public function setPassword($password = null)
    {
        // validation for constraint: maxLength
        if ((is_scalar($password) && strlen($password) > 64) || (is_array($password) && count($password) > 64)) {
            throw new \InvalidArgumentException(sprintf('Invalid length, please provide an array with 64 element(s) or a scalar of 64 character(s) at most, "%d" length given', is_scalar($password) ? strlen($password) : count($password)), __LINE__);
        }
        // validation for constraint: minLength
        if ((is_scalar($password) && strlen($password) < 1) || (is_array($password) && count($password) < 1)) {
            throw new \InvalidArgumentException('Invalid length, please provide an array with 1 element(s) or a scalar of 1 character(s) at least', __LINE__);
        }
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Get productId value
     * @return string|null
     */
    public function getProductId()
    {
        return $this->productId;
    }
    /**
     * Set productId value
     * @param string $productId
     * @return \StructType\GetAvailableChargesRequest
     */
    public function setProductId($productId = null)
    {
        // validation for constraint: maxLength
        if ((is_scalar($productId) && strlen($productId) > 64) || (is_array($productId) && count($productId) > 64)) {
            throw new \InvalidArgumentException(sprintf('Invalid length, please provide an array with 64 element(s) or a scalar of 64 character(s) at most, "%d" length given', is_scalar($productId) ? strlen($productId) : count($productId)), __LINE__);
        }
        // validation for constraint: minLength
        if ((is_scalar($productId) && strlen($productId) < 1) || (is_array($productId) && count($productId) < 1)) {
            throw new \InvalidArgumentException('Invalid length, please provide an array with 1 element(s) or a scalar of 1 character(s) at least', __LINE__);
        }
        // validation for constraint: string
        if (!is_null($productId) && !is_string($productId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($productId)), __LINE__);
        }
        $this->productId = $productId;
        return $this;
    }
    /**
     * Get localizationCountry value
     * @return string|null
     */
    public function getLocalizationCountry()
    {
        return $this->localizationCountry;
    }
    /**
     * Set localizationCountry value
     * @param string $localizationCountry
     * @return \StructType\GetAvailableChargesRequest
     */
    public function setLocalizationCountry($localizationCountry = null)
    {
        // validation for constraint: maxLength
        if ((is_scalar($localizationCountry) && strlen($localizationCountry) > 2) || (is_array($localizationCountry) && count($localizationCountry) > 2)) {
            throw new \InvalidArgumentException(sprintf('Invalid length, please provide an array with 2 element(s) or a scalar of 2 character(s) at most, "%d" length given', is_scalar($localizationCountry) ? strlen($localizationCountry) : count($localizationCountry)), __LINE__);
        }
        // validation for constraint: minLength
        if ((is_scalar($localizationCountry) && strlen($localizationCountry) < 2) || (is_array($localizationCountry) && count($localizationCountry) < 2)) {
            throw new \InvalidArgumentException('Invalid length, please provide an array with 2 element(s) or a scalar of 2 character(s) at least', __LINE__);
        }
        // validation for constraint: string
        if (!is_null($localizationCountry) && !is_string($localizationCountry)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($localizationCountry)), __LINE__);
        }
        $this->localizationCountry = $localizationCountry;
        return $this;
    }
    /**
     * Get localizationLanguage value
     * @return string|null
     */
    public function getLocalizationLanguage()
    {
        return $this->localizationLanguage;
    }
    /**
     * Set localizationLanguage value
     * @param string $localizationLanguage
     * @return \StructType\GetAvailableChargesRequest
     */
    public function setLocalizationLanguage($localizationLanguage = null)
    {
        // validation for constraint: maxLength
        if ((is_scalar($localizationLanguage) && strlen($localizationLanguage) > 2) || (is_array($localizationLanguage) && count($localizationLanguage) > 2)) {
            throw new \InvalidArgumentException(sprintf('Invalid length, please provide an array with 2 element(s) or a scalar of 2 character(s) at most, "%d" length given', is_scalar($localizationLanguage) ? strlen($localizationLanguage) : count($localizationLanguage)), __LINE__);
        }
        // validation for constraint: minLength
        if ((is_scalar($localizationLanguage) && strlen($localizationLanguage) < 2) || (is_array($localizationLanguage) && count($localizationLanguage) < 2)) {
            throw new \InvalidArgumentException('Invalid length, please provide an array with 2 element(s) or a scalar of 2 character(s) at least', __LINE__);
        }
        // validation for constraint: string
        if (!is_null($localizationLanguage) && !is_string($localizationLanguage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($localizationLanguage)), __LINE__);
        }
        $this->localizationLanguage = $localizationLanguage;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetAvailableChargesRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
